// Regle : Single rotation

int rectSize = 10;
Cellule[][] grille;
boolean cadrillageBleuOuRouge;
int nbColonne = width;
int nbLigne = height;

void setup()
{

  size(900, 800);
  frameRate(60);
  background(0);

  grille = new Cellule[nbLigne][nbColonne];

  for (int i=0; i<grille.length; i++)
  {
    for (int j=0; j< grille[0].length; j++)
      grille[i][j] = new Cellule();
  }
  
  cadrillageBleuOuRouge = true;
}

void draw()
{

  for (int i=0; i < grille.length; i++)
  {   
    for (int j=0; j<grille[0].length; j++)
      grille[i][j].afficherCarre(i, j);
  }
  parcoursTableau();
}


void parcoursTableau()
{
  if (cadrillageBleuOuRouge)
  {
    for (int i=1; i<grille.length; i= i+2)
    {
      for (int j=1; j< grille[0].length; j= j+2)
      {
        if (i == grille.length || j == grille[0].length)
          break;

        if ((j+1) == grille[0].length && ((i+1) == grille.length))   
        {
          if (grille[i][j].getCellule())
            Deplacement(grille[i][j], grille[0][j], grille[0][j+1], grille[i][j+1]);
          break;
        }

        if ((i+1) == grille.length)
        {
          if (grille[i][j].getCellule() || grille[i][j+1].getCellule())
            Deplacement(grille[i][j], grille[i][j+1], grille[0][j+1], grille[0][j]);

          break;
        }
        if ((j+1) == grille[i].length)      
        {
          if (grille[i][j].getCellule() || grille[i+1][j].getCellule())
            Deplacement(grille[i][j], grille[i][0], grille[i+1][0], grille[i+1][j]);
          break;
        }

        Deplacement(grille[i][j], grille[i][j+1], grille[i+1][j+1], grille[i+1][j]);
      }
    }
  } else
  {
    for (int i=0; i<grille.length; i= i+2)
    {
      for (int j=0; j< grille[0].length; j =j+2)
      {
        Deplacement(grille[i][j], grille[i][j+1], grille[i+1][j+1], grille[i+1][j]); // Haut, Droite, basDroite, Bas
      }
    }
  }
  cadrillageBleuOuRouge = !cadrillageBleuOuRouge;
}

void Deplacement(Cellule hautGauche, Cellule hautDroite, Cellule basDroite, Cellule basGauche)
{
  Cellule[] tab = {hautGauche, hautDroite, basDroite, basGauche};
  if (verifier(tab) != 1)
    return;

  int indice = getCelluleTrue(tab);
  if (indice == 3)
  {
    tab[indice].setCellule(false);
    tab[0].setCellule(true);
  } else
  {
    tab[indice].setCellule(false);
    indice = indice +1;
    tab[indice].setCellule(true);
  }
}

int verifier(Cellule[] tab)
{  
  int nbTrue=0;
  for (int i=0; i<tab.length; i++)
  {
    if (tab[i].getCellule())
      nbTrue++;
  }
  return nbTrue;
}

int getCelluleTrue(Cellule[] tab)
{  
  for (int i=0; i<tab.length; i++)
  {
    if (tab[i].getCellule())
      return i;
  }
  return -1;
}
